//
//  NetworkEventProducer.swift
//  VKExt
//
//  Created by programmist_NA on 10.07.2020.
//

import Foundation
import Reachability

private extension Selector {
    /// The selector to call when reachability status changes.
    static let reachabilityStatusChanged =
        #selector(NetworkEventProducer.reachabilityStatusChanged(note:))
}

/// A `NetworkEventProducer` generates `NetworkEvent`s when there is changes on the network.
class NetworkEventProducer: NSObject, EventProducer {
    /// A `NetworkEvent` is an event a network monitor.
    ///
    /// - networkChanged: The network changed.
    /// - connectionRetrieved: The connection is now up.
    /// - connectionLost: The connection has been lost.
    enum NetworkEvent: Event {
        case networkChanged
        case connectionRetrieved
        case connectionLost
    }

    /// The reachability to work with.
    let reachability: Reachability

    /// The date at which connection was lost.
    private(set) var connectionLossDate: NSDate?

    /// The listener that will be alerted a new event occured.
    weak var eventListener: EventListener?

    /// A boolean value indicating whether we're currently listening to events on the player.
    private var listening = false

    /// The last status received.
    var lastStatus: Reachability.Connection

    /// Initializes a `NetworkEventProducer` with a reachability.
    ///
    /// - Parameter reachability: The reachability to work with.
    init(reachability: Reachability) {
        lastStatus = reachability.connection
        self.reachability = reachability

        if lastStatus == .unavailable {
            connectionLossDate = NSDate()
        }
    }

    /// Stops producing events on deinitialization.
    deinit {
        stopProducingEvents()
    }

    /// Starts listening to the player events.
    func startProducingEvents() {
        guard !listening else {
            return
        }

        //Saving current status
        lastStatus = reachability.connection

        //Starting to listen to events
        NotificationCenter.default.addObserver(
            self,
            selector: .reachabilityStatusChanged,
            name: .reachabilityChanged,
            object: reachability)
        try! reachability.startNotifier()

        //Saving that we're currently listening
        listening = true
    }

    /// Stops listening to the player events.
    func stopProducingEvents() {
        guard listening else {
            return
        }

        //Stops listening to events
        NotificationCenter.default.removeObserver(
            self, name: .reachabilityChanged, object: reachability)
        reachability.stopNotifier()

        //Saving that we're not listening anymore
        listening = false
    }

    /// The method that will be called when Reachability generates an event.
    ///
    /// - Parameter note: The notification information.
    @objc fileprivate func reachabilityStatusChanged(note: NSNotification) {
        let newStatus = reachability.connection
        if newStatus != lastStatus {
            if newStatus == .unavailable {
                connectionLossDate = NSDate()
                eventListener?.onEvent(NetworkEvent.connectionLost, generetedBy: self)
            } else if lastStatus == .unavailable {
                eventListener?.onEvent(NetworkEvent.connectionRetrieved, generetedBy: self)
                connectionLossDate = nil
            } else {
                eventListener?.onEvent(NetworkEvent.networkChanged, generetedBy: self)
            }
            lastStatus = newStatus
        }
    }
}
/// An `Event` represents an event that can occur.
protocol Event {}

/// An `EventListener` listens to events generated by a `PlayerEventProducer`.
protocol EventListener: class {
    /// Called when an event occurs.
    ///
    /// - Parameters:
    ///   - event: The event that occured.
    ///   - eventProducer: The producer at the root of the event.
    func onEvent(_ event: Event, generetedBy eventProducer: EventProducer)
}

/// An `EventProducer` serves the purpose of producing events over time.
protocol EventProducer: class {
    /// The listener that will be alerted a new event occured.
    var eventListener: EventListener? { get set }

    /// Tells the producer to start producing events.
    func startProducingEvents()

    /// Tells the producer to stop producing events.
    func stopProducingEvents()
}
